


;; Conversione da virgola mobile a esadecimale.
@RealToEx macro @@Real:req,@@Precision:=<32>
	LOCAL	@NoReal			;; Flag, indica se il parametro  un numero reale corretto.
	LOCAL	@Sign			;; Testo, bit di segno.
	LOCAL	@Int			;; Testo, bit della parte intera.
	LOCAL	@Decimal		;; Testo, bit della parte decimale.
	LOCAL	@IntValue		;; Testo, parte intera ricavata dal parametro fornito.
	LOCAL	@DecValue		;; Testo, parte decimale ricavata dal parametro fornito.
	LOCAL	@IntCount		;; Valore, numero di bit necessari per la codifica della parte intera.
	LOCAL	@DecCount		;; Valore, numero di bit necessari per la codifica della parte decimale.
	LOCAL	@SignPos		;; Valore, posizione del segno nel parametro fornito.
	LOCAL	@DotPos			;; Valore, posizione del punto nel parametro fornito.
	LOCAL	@Current		;; Parametro di ciclo.
	LOCAL	@Reminder		;; Valore, unit da aggiungere nella moltiplicazione.
	LOCAL	@Value			;; Valore, variabile di supporto nei calcoli.
	LOCAL	@CharValue		;; Testo, calcolo corrente del decimale per la conversione in binario.
	LOCAL	@Exponent		;; Testo, valore dell'esponente in binario.
	LOCAL	@RealBin		;; Testo, numero reale in binario.
	LOCAL	@Count			;; Valore, contatore di ciclo per il numero di nibble.
	LOCAL	@Pos			;; Valore, posizione del nibble all'interno del testo binario.
	LOCAL	@RealHex		;; Testo, numero reale in esadecimale.
	LOCAL	@ExponentBits	;; Valore, indica il numero di bit usati dall'esponente.
	LOCAL	@Normalize		;; Flag, indica la fattibilit per la normalizzazione.
	LOCAL	@NormalizeBits	;; Valore, indica il numero di bit shiftati per normalizzare il numero.

	;; Verifica la presenza del punto, obbligatorio.
	@DotPos		instr		1,<@@Real>,<.>
	if	@DotPos eq 0
	
		;; Punto non presente.
		exitm	<>
	
	endif
	;; Filtro la stringa per accertare la presenza di soli numeri e simboli validi.
	@NoReal		=		0
	forc	@Current,<@@Real>
	
		;; Verifico la presenza del carattere corrente.
		if	(@InStr(1,-+.0123456789,@Current)) eq 0
		
			;; Errore, carattere non numerico.
			@NoReal		=		1
		
		endif
	
	endm
	;; Verifica il risultato del filtraggio.
	if	@NoReal
	
		;; Il parametro non  un numero reale corretto.
		exitm	<>
	
	endif
	;; Impostazione del numero di bit dell'esponente.
	if		@@Precision eq 32
	
		;; Singola precisione.
		@ExponentBits		=		8
	
	else
	
		;; Doppia precisione.
		@ExponentBits		=		11
	
	endif
	;; Segno positivo, bit a zero per default.
	@Sign		textequ		<0>
	;; Verifico la presenza del segno meno.
	if	@InStr(1,<@@Real>,-)
	
		;; Cambio il segno a negativo, bit a 1.
		@Sign		textequ		<1>
	
	endif
	;; Individuazione della posizione del simbolo di segno, valido per entrambi.
	@SignPos	=		@InStr(1,<@@Real>,+) + @InStr(1,<@@Real>,-)
	;; Estrae la parte intera.
	@IntValue	=		@SubStr(<@@Real>,@SignPos + 1,@DotPos - @SignPos - 1)
	;; Conversione della parte intera in testo binario.
	.radix 2
	@Int		textequ		% @IntValue
	.radix 10
	;; Conteggio del numero di bit della parte intera.
	@IntCount	sizestr		@Int

	;; Inversione della parte decimale.
	@DecValue	textequ		<>
	%forc	@Current,@SubStr(<@@Real>,@DotPos + 1)
	
		@DecValue	catstr		<@Current>,@DecValue
	
	endm
	;; Calcolo del numero di bit utilizzabili per la parte decimale.
	@DecCount	=			@@Precision - @ExponentBits - @IntCount
	;; Ciclo di conversione in binario della parte decimale.
	@Decimal		textequ		<>
	@NormalizeBits	=			0
	@Normalize		=			1
	repeat	@DecCount
	
		;; Moltiplica per 2.
		@CharValue	textequ		<>
		@Reminder	textequ		<0>
		%forc	@Current,<@DecValue>
		
			;; Individuo la cifra.
			@Pos		instr		1,<0123456789>,<@Current>
			;; Creo la nuova stringa del risultato.
			@CharValue	catstr		@CharValue,@SubStr(<01234567890123456789>,(@Pos * 2) - 1 + @Reminder,1)
			@Reminder	substr		<00000000001111111111>,(@Pos * 2) - 1 + @Reminder,1
		
		endm
		;; Aggiornamento del valore
		@DecValue	textequ		@CharValue
		;; Aggiunta del bit.
		@Decimal	catstr		@Decimal,@Reminder
		;; Verifica la presenza di una eventuale normalizzazione.
		if	@Normalize eq 1
		
			ifidni	@Int,<0>
			
				;; Conteggio del numero di bit.
				@NormalizeBits	=		@NormalizeBits + 1
				ifidni	@Reminder,<1>
				
					;; Concludi la normalizzazione.
					@Normalize		=		0
				
				endif
			
			endif
		
		endif
	
	endm
	;; Effettua l'eventuale normalizzazione.
	if	@NormalizeBits ne 0
	
		;; Verifica il numero di bit coinvolti dalla normalizzazione.
		if	@NormalizeBits ge (@@Precision - @ExponentBits - 1)
		
			;; Tutti i bit sono a zero, quindi annullo la normalizzazione.
			if	@@Precision eq 32
			
				;; Significando a 23 bit
				@Decimal		textequ		<00000000000000000000000>
				;; Imposta il valore di normalizzazione per azzerare l'esponente.
				@NormalizeBits	=			127
			
			else
			
				;; Significando a 52 bit
				@Decimal		textequ		<0000000000000000000000000000000000000000000000000000>
				;; Imposta il valore di normalizzazione per azzerare l'esponente.
				@NormalizeBits	=			1023
			
			endif
		
		else
		
			;; Rimuovi il numero di bit necessari per la normalizzazione.
			@Decimal	substr		@Decimal,@NormalizeBits + 1
			;; Integra i bit mancanti.
			repeat	@NormalizeBits
			
				;; Moltiplica per 2.
				@CharValue	textequ		<>
				@Reminder	textequ		<0>
				%forc	@Current,<@DecValue>
				
					;; Individuo la cifra.
					@Pos		instr		1,<0123456789>,<@Current>
					;; Creo la nuova stringa del risultato.
					@CharValue	catstr		@CharValue,@SubStr(<01234567890123456789>,(@Pos * 2) - 1 + @Reminder,1)
					@Reminder	substr		<00000000001111111111>,(@Pos * 2) - 1 + @Reminder,1
				
				endm
				;; Aggiornamento del valore
				@DecValue	textequ		@CharValue
				;; Aggiunta del bit.
				@Decimal	catstr		@Decimal,@Reminder
			
			endm
		
		endif
	
	endif
	;; Verifica la presenza di un valore residuo.
	@Value		=		0
	%forc	@Current,<@DecValue>
	
		ifdif	<@Current>,<0>
		
			;; Imposta il flag di presenza di un valore residuo.
			@Value		=		1
			exitm
		
		endif
	
	endm
	if	@Value ne 0
	
		;; Inverte il testo binario.
		@DecValue	textequ		<>
		%forc	@Current,<@Decimal>
		
			@DecValue	catstr		<@Current>,@DecValue
		
		endm
		;; Ciclo di rettifica al testo binario della parte decimale.
		@CharValue	textequ		<>
		@Reminder	textequ		<1>
		%forc	@Current,<@DecValue>
		
			;; Individuo la cifra.
			@Pos		=			@Current + @Reminder + 1
			;; Creo la nuova stringa del risultato.
			@CharValue	catstr		@SubStr(<010>,@Pos,1),@CharValue
			@Reminder	substr		<001>,@Pos,1
		
		endm
		@Decimal	textequ		@CharValue
	
	endif
	;; Conversione dell'esponente in testo binario.
	if	@@Precision eq 32
	
		@Value		=			126 + @IntCount - @NormalizeBits
	
	else
	
		@Value		=			1022 + @IntCount - @NormalizeBits
	
	endif
	;; Conversione dell'esponente in testo binario.
	.radix 2
	@Exponent	textequ		% @Value
	.radix 10
	;; Verifico se  necessario integrare con dei bit 0.
	if	@SizeStr(%@Exponent) ne @ExponentBits
	
		;; Correzione della dimensione dell'esponente.
		@Exponent		textequ		@CatStr(@SubStr(<00000000000>,1,@ExponentBits - @SizeStr(%@Exponent)),%@Exponent)
	
	endif
	;; Creazione del testo binario del numero reale.
	if	@IntCount gt 1
	
		@RealBin	textequ		@CatStr(%@Sign,%@Exponent,@SubStr(%@Int,2),%@Decimal)
	
	else
	
		@RealBin	textequ		@CatStr(%@Sign,%@Exponent,%@Decimal)
	
	endif
	;; Conversione del testo binario in esadecimale.
	@Count		=			@@Precision / 4
	@Pos		=			1
	@RealHex	textequ		<>
	repeat	@Count
	
		;; Valore del nibble corrente.
		@Value		=			@CatStr(@SubStr(%@RealBin,@Pos,4),<y>)
		.radix	16
		;; Conversione del nibble in esadecimale.
		@RealHex	catstr		@RealHex,%@Value
		.radix	10
		;; Nibble successivo.
		@Pos		=			@Pos + 4
	
	endm
	@RealHex	catstr		<0>,@RealHex,<h>
	exitm @RealHex

endm





;; Macro per i numeri reali a singola precisione (32 bit).
r4 macro @@Real4:req

	exitm	@RealToEx(@@Real4)

endm





;; Macro per i numeri reali a doppia precisione (64 bit).
r8 macro @@Real8:req

	exitm	@RealToEx(@@Real8,64)

endm





;; Macro per l'inserimento di un numero reale in una variabile.
movr4 macro @@Name:req,@@Real4:req

	mov		@@Name,r4(@@Real4)

endm





;; Macro per l'inserimento di un numero reale in una variabile.
movr8 macro @@Name:req,@@Real8:req
	LOCAL	@Real,@First,@Last

	;; Acquisizione del testo esadecimale.
	@Real	textequ		r8(@@Real8)
	@First	textequ		<>
	@Last	textequ		<>
	;; Suddivisione del testo in due parti.
	ifnb	@Real
	
		@First	catstr		@SubStr(%@Real,1,9),<h>
		@Last	catstr		<0>,@SubStr(%@Real,10)
	
	endif
	mov		DWORD PTR [4][@@Name],@First
	mov		DWORD PTR [@@Name],@Last

endm





;; Macro per l'inserimento di un numero reale nello stack.
pushr4 macro @@Real4:req

	push	r4(@@Real4)

endm





;; Macro per l'inserimento di un numero reale nello stack.
pushr8 macro @@Real8:req
	LOCAL	@Real,@First,@Last

	;; Acquisizione del testo esadecimale.
	@Real	textequ		r8(@@Real8)
	;; Verifica se  stato fornito un numero reale o una variabile.
	ifnb	@Real
	
		;; Suddivisione del testo in due parti
		@First	catstr		@SubStr(%@Real,1,9),<h>
		@Last	catstr		<0>,@SubStr(%@Real,10)
		push	@First
		push	@Last
	
	else
	
		;; Inserimento della variabile.
		push	DWORD PTR [4][@@Real8]
		push	DWORD PTR [@@Real8]
	
	endif

endm
